/*******************************************************************************
 * Copyright (c) 2004, 2005 Sybase, Inc. and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Sybase, Inc. - initial API and implementation
 *******************************************************************************/
package org.eclipse.jst.jsf.facesconfig.ui.pageflow.properties;

/**
 * @author jchoi
 * @version
 */
public interface ITabbedPropertiesConstants {
	/**
	 * used to set grid data height hints on dialog fields
	 */
	public static int BROWSE_HEIGHT = 18;

	/**
	 * used to set grid data width hints on dialog fields
	 */
	public static int BROWSE_WIDTH = 20;

	/**
	 * the general tag id
	 */
	public static final String GENERAL_TAB_ID = "org.eclipse.jst.jsf.facesconfig.ui.pageflow.properties.general"; //$NON-NLS-1$

	/**
	 * the attribute tag id
	 */
	public static final String ATTRIBUTE_TAB_ID = "org.eclipse.jst.jsf.facesconfig.ui.pageflow.properties.attribute"; //$NON-NLS-1$

	/**
	 * the link section id
	 */
	public static final String LINK_SECTION = "attribute.link"; // 4 //$NON-NLS-1$

	/**
	 * the page section id
	 */
	public static final String PAGE_SECTION = "attribute.page"; // 3 //$NON-NLS-1$

	/**
	 * the editor section id
	 */
	public static final String EDITOR_SECTION = "attribute.editor"; // 1 //$NON-NLS-1$

	/**
	 * the top section id
	 */
	public static final String TOP_SECTION = "top"; // 0 //$NON-NLS-1$

}
